/***************************************************************************
*   Copyright (C) 2005 by Achal Dhir                                      *
*   achaldhir@gmail.com                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

// dualserver.cpp
#include <sys/types.h>
#include <limits.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <limits.h>
#include <memory.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <syslog.h>
#include <string>
#include <map>
#include "dualserver.h"
using namespace std;


//Function Prototypes
DWORD my_inet_addr(char*);
WORD pQu(char*, char*);
WORD fQu(char*, dnsPacket*, char*);
DWORD fLong(char*);
WORD fShort(char*);
BYTE pLong(char*, DWORD);
BYTE pShort(char*, WORD);
WORD gdmess(data1*);
DWORD sdmess(data1*);
void gvdata(data1*, data3*);
BYTE *pvdata(BYTE*, data1*, data3*);
void indata();
BYTE *addOp(data1*);
char* IP2String(DWORD ip);
time_t getExpiry(dnsPacket*);
char* getResult(dnsPacket*);
DWORD resad(data1*);
DWORD chad(DWORD, data1*);
DWORD alad(data1*);
WORD gdnmess(data5*);
WORD scanloc(data5*);
void getClInfo(data5 *req);
int sdnmess(data5*);
WORD fdnmess(data5*);
WORD frdnmess(data5*);
void getdnserv();
void glocal();
char* cleanstr(char*, BOOL);
BOOL getSection(char*, char*, int, char*);
int getIndex(DWORD);
DWORD getNetwork(DWORD);
void loadOptions(BYTE*, WORD, char*, char*, int);
char *getHexValue(BYTE*, char*);
char *myLower(char *string);
char *myUpper(char *string);
BYTE addServer(DWORD*, DWORD);
BYTE makeBare(char*);
void addToCache(char*, DWORD, time_t, BYTE, BYTE);
void checkSize();
DWORD checkDNS(DWORD ip);
void runprog();

//Global Variables
data2 cfig;
struct agecmp
{
	bool operator()(data7 *s1, data7 *s2) const
	{
		return (s1->expiry < s2->expiry);
	}
};
typedef map<string, data7*> myMap;
typedef multimap<long, data7*> myMultiMap;
myMap dnsCache;
myMultiMap dnsAge;
char tempbuff[256];
char iniFile[] = "/etc/dualserver.ini";
char leaFile[] = "/etc/dualserver.state";
BOOL dhcpService = true;
BOOL dnsService = true;
BOOL verbatim;
timeval tv;
fd_set readfds;
fd_set writefds;
BYTE op_index[] = {2, 4, 5, 7, 8, 9, 10, 11, 16, 19, 20, 21, 21, 95, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 44, 45, 46, 47, 48, 49, 58, 59, 62, 63, 64, 65, 128, 68, 69, 70, 71, 72, 73, 74, 75, 76, 83, 85, 86, 87, 116, 117, 118, 119, 128, 129, 130, 131, 135, 176, 0, 128, 67, 13, 17, 18, 0, 12, 3, 6};
BYTE op_size[] = {4, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 255, 1, 4, 2, 2, 1, 0, 1, 1, 1, 0, 0, 0, 1, 4, 1, 1, 4, 1, 255, 0, 0, 0, 0, 1, 255, 0, 0, 4, 4, 255, 0, 255, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 255, 255, 1, 2, 0, 255, 0, 0, 255, 0, 0, 255, 1, 0, 255, 2, 255, 255, 255, 255, 0, 0};
char op_name[][40] =
    {
        "Time_Offset",
        "Time_Server",
        "Name_Server",
        "Log_Server",
        "Cookie_Server",
        "LPR_Server",
        "Impress_Server",
        "RLP_Server",
        "Swap_Server",
        "Forward_On/Off",
        "SrcRte_On/Off",
        "Policy_Filter_IP",
        "Policy_Filter_Mask",
        "LDAP_URL",
        "Default_IP_TTL",
        "MTU_Timeout",
        "MTU_Plateau",
        "MTU_Interface",
        "MTU_Subnet",
        "Broadcast_Address",
        "Mask_Discovery",
        "Mask_Supplier",
        "Router_Discovery",
        "Router_Request",
        "Static_Route_IP",
        "Static_Route_Mask",
        "Trailers",
        "ARP_Timeout",
        "Ethernet_Encp",
        "Default_TCP_TTL",
        "Keepalive_Time",
        "Keepalive_Data",
        "NIS_Domain",
        "NIS_Servers",
        "NTP_Servers",
        "NETBIOS_Name_Srv",
        "NETBIOS_Dist_Srv",
        "NETBIOS_Node_Type",
        "NETBIOS_Scope",
        "X_Window_Font",
        "X_Window_Manager",
        "Renewal_Time",
        "Rebinding_Time",
        "Netware/IP_Domain",
        "Netware/IP_Option",
        "NIS+_Domain_Name",
        "NIS+_Server_Addr",
        "TFTP_Server_Name",
        "Home_Agent_Addrs",
        "SMTP_Server",
        "POP3_Server",
        "NNTP_Server",
        "WWW_Server",
        "Finger_Server",
        "IRC_Server",
        "StreetTalk_Server",
        "STDA_Server",
        "iSNS",
        "NDS_Servers",
        "NDS_Tree_Name",
        "NDS_Context",
        "Auto_Configure",
        "Name_Service_Search",
        "Subnet_Selection",
        "DNS_Domain_Search",
        "TFTP_Server",
        "Call_Server",
        "Discrimination_String",
        "RemoteStatisticsServer",
        "Phone_Http_Proxy",
        "IP_Phone",
        "Send_Only_Requested_Options",
        "Next_Server",
        "Boot_File",
        "Boot_File_Size",
        "Root_Path",
        "Extension_Path",
        "Hardware_Addr",
        "Hostname",
        "Router",
        "DNS_Server"
    };

int main(int argc, char **argv)
{
	verbatim = (argc > 1 && !strcasecmp(argv[1], "-v"));
	if (verbatim)
	{
		if (getuid())
		{
			printf("Error: Only root should run this program\n");
			exit(1);
		}

		//printf("%i\n",sizeof(data7));
		verbatim = true;
		data1 dhcpr;
		data5 dnsr;
		indata();

		if (dnsService && dhcpService)
			printf("\nStarting DNS Service..\nStarting DHCP Service..\n\nForwarding DNS Servers: ");
		else if (dnsService)
			printf("\nStarting DNS Service..\n\nForwarding DNS Servers: ");
		else
		{
			printf("\nStarting DHCP Service..\n\nDNS Servers: ");
		}

		for (int i = 0; cfig.dns[i];i++)
			printf("%s ", IP2String(cfig.dns[i]));

		printf("\nIP Range: %s", IP2String(htonl(cfig.ranges[0].rangeStart)));
		printf(" - %s", IP2String(htonl(cfig.ranges[0].rangeEnd)));

		if (dhcpService)
		{
			printf("\nDefault Gateways: ");
			for (int i = 0; cfig.routers[i];i++)
				printf("%s ", IP2String(cfig.routers[i]));
		}

		if (dnsService)
		{
			printf("%s", "\nDNS Service Permitted Hosts:\t");
			for (int i = 0; i <= 5 && cfig.ranges[i].rangeStart; i++)
			{
				printf("\n%s - ", IP2String(htonl(cfig.ranges[i].rangeStart)));
				printf("%s", IP2String(htonl(cfig.ranges[i].rangeEnd)));
			}
		}

		printf("\nServer Name: %s", cfig.servername);

		if (cfig.authorized)
			printf("\nLocal Zone: %s (authorized)", cfig.domainname);
		else
			printf("\nLocal Zone: %s (not authorized)", cfig.domainname);

		printf("\nStatic Interface in IP Range Network: ");

		if (cfig.servers[0])
			for (int i = 0; cfig.servers[i];i++)
			{
				printf("%s", IP2String(cfig.servers[i]));
				printf("/%s ", IP2String(cfig.subnetmask));
			}
		else
			printf("%s ", "none found");

		if (cfig.lease == LONG_MAX)
			printf("\nMax Lease Time/Expiry: Infinity");
		else
			printf("\nMax Lease Time/Expiry: %u (sec)", cfig.lease);

		printf("\nListening On: %s", IP2String(cfig.serverip));
		printf("\n\nAccepting requests..\n");

		while (true)
		{
			FD_ZERO(&readfds);
			tv.tv_sec = 10;
			tv.tv_usec = 0;


			if (dhcpService)
				FD_SET(cfig.socket[0], &readfds);

			if (dnsService)
			{
				FD_SET(cfig.socket[1], &readfds);
				FD_SET(cfig.socket[2], &readfds);
			}

			select(USHRT_MAX, &readfds, NULL, NULL, &tv);

			if (dhcpService)
				if (FD_ISSET(cfig.socket[0], &readfds))
				{
					if (gdmess(&dhcpr))
					{
						if (sdmess(&dhcpr))
							if (dhcpr.resp_type == DHCP_MESS_ACK)
								printf("Host %s alotted %s for %u seconds\n", dhcpr.hostname, IP2String(dhcpr.dhcpp.bp_yiaddr), dhcpr.lease);
					}
				}

			if (dnsService)
			{
				if (FD_ISSET(cfig.socket[2], &readfds))
				{
					if (frdnmess(&dnsr))
					{
						sdnmess(&dnsr);
						if (getResult(&dnsr.dnsp))
							printf("%s resolved from Forwarding server as %s\n", dnsr.query, tempbuff);
					}
				}

				if (FD_ISSET(cfig.socket[1], &readfds))
				{
					if (gdnmess(&dnsr))
					{
						if (dnsr.dnsp.header.rcode == 5)
						{
							printf("Client %s, DNS Query, Access Denied\n", inet_ntoa(dnsr.sockAddr.sin_addr));
							sdnmess(&dnsr);
						}
						else if (scanloc(&dnsr))
						{
							if (htons(dnsr.dnsp.header.ancount))
							{
								if (dnsr.cache.dataType == CACHED)
									printf("%s resolved from Cache to %s\n", dnsr.query, getResult(&dnsr.dnsp));
								else
									printf("%s resolved Locally to %s\n", dnsr.query, getResult(&dnsr.dnsp));
							}
							sdnmess(&dnsr);
						}
						else if (!fdnmess(&dnsr))
							printf("Failed to forward query %s\n", dnsr.cname);
					}
				}
			}
		}
	}
	else
	{
		if (getuid())
		{
			syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Only root should run this program");
			exit(1);
		}

		/* Our process ID and Session ID */
		pid_t pid, sid;

		/* Fork off the parent process */
		pid = fork();
		if (pid < 0)
		{
			exit(EXIT_FAILURE);
		}
		/* If we got a good PID, then
		we can exit the parent process. */
		if (pid > 0)
		{
			exit(EXIT_SUCCESS);
		}

		/* Change the file mode mask */
		umask(0);

		/* Open any logs here */

		/* Create a new SID for the child process */
		sid = setsid();
		if (sid < 0)
		{
			/* Log the failure */
			exit(EXIT_FAILURE);
		}

		/* Change the current working directory */
		if ((chdir("/")) < 0)
		{
			/* Log the failure */
			exit(EXIT_FAILURE);
		}

		/* Close out the standard file descriptors */
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);

		/* Daemon-specific initialization goes here */
		data1 dhcpr;
		data5 dnsr;
		indata();

		/* The Big Loop */
		while (1)
		{
			tv.tv_sec = 10;
			tv.tv_usec = 0;
			FD_ZERO(&readfds);

			if (dhcpService)
				FD_SET(cfig.socket[0], &readfds);

			if (dnsService)
			{
				FD_SET(cfig.socket[1], &readfds);
				FD_SET(cfig.socket[2], &readfds);
			}

			select(USHRT_MAX, &readfds, NULL, NULL, &tv);

			if (dhcpService)
				if (FD_ISSET(cfig.socket[0], &readfds))
				{
					if (gdmess(&dhcpr))
					{
						sdmess(&dhcpr);
					}
				}

			if (dnsService)
			{
				if (FD_ISSET(cfig.socket[2], &readfds))
				{
					if (frdnmess(&dnsr))
					{
						sdnmess(&dnsr);
					}
				}

				if (FD_ISSET(cfig.socket[1], &readfds))
				{
					if (gdnmess(&dnsr))
					{
						if (dnsr.dnsp.header.rcode == 5)
							sdnmess(&dnsr);
						else if (scanloc(&dnsr))
							sdnmess(&dnsr);
						else
							fdnmess(&dnsr);
					}
				}
			}
		}

	}
	exit(EXIT_SUCCESS);
}

WORD fQu(char *name, dnsPacket *mess, char *raw)
{
	BYTE *xname = (BYTE*)name;
	BYTE *xraw = (BYTE*)raw;
	WORD retvalue = 0;
	BOOL goneout = false;
	while (true)
	{
		WORD size = (BYTE) * xraw;
		xraw++;
		if (!size)
		{
			break;
		}
		else if (size <= 63)
		{
			if (!goneout)
				retvalue += (size + 1);
			memcpy(xname, xraw, size);
			xname += size;
			xraw += size;
			if (!*xraw)
				break;
			*xname = '.';
			xname++;
		}
		else
		{
			if (!goneout)
				retvalue += 2;
			goneout = true;
			size %= 128;
			size %= 64;
			size *= 256;
			size += *xraw;
			if (size > sizeof(dnsPacket))
				break;
			xraw = (BYTE*)mess + size;
		}
	}
	*xname = 0;
	if (!goneout)
		retvalue++;
	return retvalue;
}

WORD pQu(char *raw, char *name)
{
	WORD fullsize = 1;
	while (true)
	{
		char *i = strchr(name, '.');
		if (i != NULL)
		{
			int size = (DWORD)i - (DWORD)name;
			*raw = size;
			raw++;
			memcpy(raw, name, size);
			raw += size;
			name += (size + 1);
			fullsize += (size + 1);
		}
		else
		{
			int size = strlen(name);
			*raw = size;
			raw++;
			strcpy(raw, name);
			fullsize += (size + 1);
			break;
		}
	}
	return fullsize;
}

WORD genMess(data5 *req)
{
	//printf("%i\n", req->cache.dataType);
	time_t currentTime = time(NULL);
	WORD xid = req->dnsp.header.xid;

	req->dnsp.header.nscount = 0;
	req->dnsp.header.adcount = 0;
	req->dnsp.header.qr = 1;
	req->dnsp.header.aa = 1;

	char *raw = req->dnsp.data;

	for (int i = 1; i <= ntohs(req->dnsp.header.qdcount); i++)
	{
		raw += fQu(tempbuff, &req->dnsp, raw);
		raw += 4;
	}

	switch (req->cache.dataType)
	{
	case UNKNOWN:
		req->dnsp.header.ancount = 0;
		req->dnsp.header.rcode = 3;
		req->dnsp.header.ra = 0;
		break;

	case CACHED:
		if (strcasecmp(req->cname, req->query))
		{
			//manuplate the response
			req->dnsp.header.qdcount = htons(1);
			req->dnsp.header.ancount = htons(1);
			req->dnsp.header.nscount = htons(0);
			req->dnsp.header.adcount = htons(0);

			raw += pQu(raw, req->query);
			raw += pShort(raw, DNS_TYPE_CNAME);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, cfig.lease);
			raw += pShort(raw, strlen(req->cname) + 2);
			raw += pQu(raw, req->cname);

			dnsPacket *packet = (dnsPacket*)req->cache.response;
			char *dp = packet->data;

			for (int i = 1; i <= ntohs(packet->header.qdcount); i++)
			{
				if ((BYTE)*dp > 63)
					dp += 2;
				else
					dp += strlen(dp) + 1;
				dp += 4;
			}

			char tempdata[256];
			WORD dl = 0;
			for (int i = 1; i <= ntohs(packet->header.ancount); i++)
			{
				char *xraw = tempdata;
				dp += fQu(tempbuff, packet, dp);
				xraw += pQu(xraw, tempbuff);
				memcpy(xraw, dp, 8);
				xraw += 8;
				int type = fShort(dp);
				dp += 2; //type
				dp += 2; //class
				dp += 4; //ttl
				WORD dlen = fShort(dp);
				dp += 2; //datalength

				switch (type)
				{
				case DNS_TYPE_A:
					xraw += pShort(xraw, dlen);
					xraw += pLong(xraw, fLong(dp));
					break;
				case DNS_TYPE_CNAME:
					fQu(tempbuff, packet, dp);
					dl = pQu(xraw + 2, tempbuff);
					xraw += pShort(xraw, dl);
					xraw += dl;
					break;
				case DNS_TYPE_MX:
					fQu(tempbuff, packet, dp + 2);
					dl = pQu(xraw + 4, tempbuff);
					xraw += pShort(xraw, dl + 2);
					pShort(xraw, fShort(dp));
					xraw += dl;
					break;
				}
				dp += dlen;

				if ((DWORD)raw - (DWORD)&req->dnsp + (DWORD)xraw - (DWORD)tempdata < sizeof(dnsPacket))
				{
					req->dnsp.header.ancount = htons(htons(req->dnsp.header.ancount) + 1);
					memcpy(raw, tempdata, ((DWORD)xraw - (DWORD)tempdata));
					raw += ((DWORD)xraw - (DWORD)tempdata);
				}
			}
			break;
		}
		else
		{
			memcpy(&req->dnsp, req->cache.response, req->cache.bytes);
			req->bytes = req->cache.bytes;
			req->dnsp.header.xid = xid;
			return req->bytes;
		}

	case LOCAL_A:
	case SERVER_A:
	case STATIC_A:
	case CNAME_LOCAL:

		req->dnsp.header.ancount = htons(0);
		if (req->cache.expiry > cfig.lease + currentTime)
			req->cache.expiry = cfig.lease + currentTime;

		if (strcasecmp(req->query, req->cname))
		{
			req->dnsp.header.ancount = htons(1);
			raw += pQu(raw, req->query);
			raw += pShort(raw, DNS_TYPE_CNAME);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, cfig.lease);
			raw += pShort(raw, strlen(req->cname) + 2);
			raw += pQu(raw, req->cname);
		}

		if (req->cache.ip)
		{
			req->dnsp.header.ancount = htons(htons(req->dnsp.header.ancount) + 1);
			raw += pQu(raw, req->cname);
			raw += pShort(raw, DNS_TYPE_A);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, (req->cache.expiry - currentTime));
			raw += pShort(raw, 4);
			memcpy(raw, &req->cache.ip, 4);
			raw += 4;
		}
		break;

	case LOCAL_PTR:
	case SERVER_PTR:
	case STATIC_PTR:

		req->dnsp.header.ancount = htons(1);
		if (req->cache.expiry > cfig.lease + currentTime)
			req->cache.expiry = cfig.lease + currentTime;

		raw += pQu(raw, req->query);
		raw += pShort(raw, DNS_TYPE_PTR);
		raw += pShort(raw, DNS_CLASS_IN);
		raw += pLong(raw, (req->cache.expiry - currentTime));
		if (strncmp(req->query, "1.0.0.127", 9))
		{
			sprintf(tempbuff, "%s.%s", req->cache.response, cfig.domainname);
			raw += pShort(raw, strlen(tempbuff) + 2);
			raw += pQu(raw, tempbuff);
		}
		else
		{
			raw += pShort(raw, strlen(req->cache.response) + 2);
			raw += pQu(raw, req->cache.response);
		}
		break;

	case MX:
		if (req->cache.expiry > cfig.lease + currentTime)
			req->cache.expiry = cfig.lease + currentTime;

		int m = 0;
		for (; m < 5 && cfig.mxServers[m].hostname[0]; m++)
		{
			raw += pQu(raw, req->query);
			raw += pShort(raw, DNS_TYPE_MX);
			raw += pShort(raw, DNS_CLASS_IN);
			raw += pLong(raw, (req->cache.expiry - currentTime));
			raw += pShort(raw, strlen(cfig.mxServers[m].hostname) + 4);
			raw += pShort(raw, cfig.mxServers[m].pref);
			raw += pQu(raw, cfig.mxServers[m].hostname);
		}
		req->dnsp.header.ancount = htons(m);
		break;
	}

	switch (req->cache.dataType)
	{
	case LOCAL_A:
	case SERVER_A:
	case STATIC_A:
	case LOCAL_PTR:
	case SERVER_PTR:
	case STATIC_PTR:
	case CNAME_LOCAL:
	case UNKNOWN:

		if (cfig.servers[0] && req->local && cfig.authorized)
		{
			req->dnsp.header.nscount = htons(1);
			req->dnsp.header.adcount = htons(1);

			if (req->qtype == DNS_TYPE_PTR)
			{
				if (cfig.serverip)
					IP2String(htonl(cfig.serverip));
				else
					IP2String(htonl(cfig.servers[0]));
				strcat(tempbuff, ".in-addr.arpa");
				char *x = strchr(tempbuff, '.');
				x++;
				raw += pQu(raw, x);
			}
			else
				raw += pQu(raw, cfig.domainname);

			raw += pShort(raw, DNS_TYPE_NS);
			raw += pShort(raw, DNS_CLASS_IN);

			if (cfig.lease >= LONG_MAX / 24)
				raw += pLong(raw, LONG_MAX);
			else
				raw += pLong(raw, 24 * cfig.lease);

			raw += pShort(raw, strlen(cfig.servername_fqn) + 2);
			raw += pQu(raw, cfig.servername_fqn);

			raw += pQu(raw, cfig.servername_fqn);
			raw += pShort(raw, DNS_TYPE_A);
			raw += pShort(raw, DNS_CLASS_IN);

			if (cfig.lease >= LONG_MAX / 24)
				raw += pLong(raw, LONG_MAX);
			else
				raw += pLong(raw, 24 * cfig.lease);

			raw += pShort(raw, sizeof(DWORD));

			if (cfig.serverip)
				memcpy(raw, &cfig.serverip, sizeof(DWORD));
			else
				memcpy(raw, &cfig.servers[0], sizeof(DWORD));

			raw += sizeof(DWORD);
		}
	}
	req->bytes = ((DWORD)raw - (DWORD)req->raw);
	req->dnsp.header.xid = xid;
	return req->bytes;
}

WORD fShort(char *raw)
{
	return ntohs(*(WORD*)raw);
}

DWORD fLong(char *raw)
{
	return ntohl(*(DWORD*)raw);
}

BYTE pShort(char *raw, WORD data)
{
	*(WORD*)raw = htons(data);
	return sizeof(WORD);
}

BYTE pLong(char *raw, DWORD data)
{
	*(DWORD*)raw = htonl(data);
	return sizeof(DWORD);
}

WORD gdnmess(data5 *req)
{
	errno = 0;
	memset(req, 0, sizeof(data5));
	socklen_t nLen = sizeof(req->sockAddr);
	req->bytes = recvfrom(cfig.socket[1],
	                      req->raw,
	                      sizeof(dnsPacket),
	                      0,
	                      (LPSOCKADDR) & req->sockAddr,
	                      &nLen);

	if (errno)
		return 0;

	DWORD ip = req->sockAddr.sin_addr.s_addr;

	for (int i = 0; i <= 5; i++)
	{
		if (ip == cfig.servers[i])
			return req->bytes;
	}

	ip = ntohl(ip);

	for (int i = 0; i < 32; i++)
	{
		if (cfig.ranges[i].rangeStart)
		{
			if (ip >= cfig.ranges[i].rangeStart && ip <= cfig.ranges[i].rangeEnd)
				return req->bytes;
		}
		else
			break;
	}

	req->dnsp.header.ancount = 0;
	req->dnsp.header.rcode = 5;
	req->dnsp.header.qr = 1;
	req->dnsp.header.ra = 0;

	return req->bytes;
}

int sdnmess(data5 *req)
{
	errno = 0;
	req->bytes = sendto(cfig.socket[1],
	                    req->raw,
	                    req->bytes,
	                    0,
	                    (LPSOCKADDR)&req->sockAddr,
	                    sizeof(req->sockAddr));

	if (errno || req->bytes <= 0)
		return 0;

	return req->bytes;
}

WORD scanloc(data5 *req)
{
	time_t currentTime = time(NULL);

	if (ntohs(req->dnsp.header.qdcount) == 1 && ntohs(req->dnsp.header.opcode) == 0)
	{
		char *raw = req->dnsp.data;
		raw += fQu(req->query, &req->dnsp, raw);

		if (!req->query[0])
			return 0;

		req->qtype = fShort(raw);
		raw += 2;
		req->qclass = fShort(raw);

		strcpy(req->mapname, req->query);
		strcpy(req->cname, req->query);
		myLower(req->mapname);

		if (req->qtype == DNS_TYPE_PTR)
		{
			char *dp = strstr(req->mapname, ".in-addr.arpa");
			if (dp)
			{
				*dp = 0;
				if (getIndex(htonl(my_inet_addr(req->mapname))) >= 0)
					req->local = 1;
			}
		}
		else
		{
			if (req->qclass == DNS_CLASS_IN && req->qtype == DNS_TYPE_MX && !strcasecmp(req->cname, cfig.domainname))
			{
				req->cache.expiry = cfig.lease + currentTime;
				req->cache.dataType = MX;
				return genMess(req);
			}
			else if (!strcasecmp(req->cname, cfig.domainname))
			{
				sprintf(req->cname, "www.%s", cfig.domainname);
				sprintf(req->mapname, "www.%s", cfig.domainname);
			}

			if (!strchr(req->cname, '.'))
			{
				sprintf(req->cname, "%s.%s", req->query, cfig.domainname);
				req->local = 1;
			}
			else
			{
				req->local = makeBare(req->mapname);
			}
		}

		if (req->qclass == DNS_CLASS_IN && (req->qtype == DNS_TYPE_A || req->qtype == DNS_TYPE_AAAA || req->qtype == DNS_TYPE_PTR))
		{
			memset(&req->cache, 0, sizeof(data7));

			for (int m = 0; m < 5; m++)
			{
				data7 *cache = dnsCache[req->mapname];

				if (cache)
				{
					//printf("datatype=%i exp=%u\n",cache->dataType,cache->expiry);
					switch (cache->dataType)
					{
					case CACHED:
						if (cache->expiry >= currentTime)
						{
							memcpy(&req->cache, cache, sizeof(data7));
							return genMess(req);
						}
						break;

					case LOCAL_A:
					case LOCAL_PTR:
						if (cache->expiry < currentTime)
							memset(&req->cache, 0, sizeof(data7));
						else
							memcpy(&req->cache, cache, sizeof(data7));

						return genMess(req);

					case STATIC_A:
					case STATIC_PTR:
					case SERVER_A:
					case SERVER_PTR:
						memcpy(&req->cache, cache, sizeof(data7));
						return genMess(req);

					case CNAME_LOCAL:
						strcpy(req->mapname, cache->response);
						sprintf(req->cname, "%s.%s", req->mapname, cfig.domainname);
						myLower(req->mapname);
						memcpy(&req->cache, cache, sizeof(data7));
						continue;

					case CNAME_EXT:
						strcpy(req->mapname, cache->response);
						sprintf(req->cname, cache->response);
						myLower(req->mapname);
						memcpy(&req->cache, cache, sizeof(data7));
						continue;
					}
				}

				if (req->cache.dataType == CNAME_EXT)
				{
					char *px = req->dnsp.data;
					px += pQu(px, req->cname);
					px += pShort(px, DNS_TYPE_A);
					px += pShort(px, DNS_CLASS_IN);
					req->bytes = (DWORD)px - (DWORD) & req->dnsp;
					return 0;
				}
				else if (req->local)
				{
					req->cache.ip = 0;
					return genMess(req);
				}
				else
				{
					break;
				}
			}
		}
	}
	return 0;
}

WORD fdnmess(data5 *req)
{
	char mapname[8];
	sprintf(mapname, "%u", req->dnsp.header.xid);
	checkSize();
	data7 *queue = dnsCache[mapname];

	if (queue && queue->dataType == QUEUE && !queue->expiry && !strcasecmp(queue->query, req->query))
		return req->bytes;

	BOOL tryDefault = true;
	BYTE routeDNS;
	int nRet = -1;
	char *dp = strchr(req->mapname, '.');
	if (dp)
	{
		dp++;
		for (routeDNS = 0; routeDNS < 32 && cfig.dnsRoutes[routeDNS].domain[0]; routeDNS++)
		{
			//printf("%s=%s\n", req->mapname, cfig.dnsRoutes[routeDNS].domain);
			if (!strcasecmp(dp, cfig.dnsRoutes[routeDNS].domain) || !strcasecmp(req->mapname, cfig.dnsRoutes[routeDNS].domain))
			{
				tryDefault = false;
				cfig.sockAddr[2].sin_family = AF_INET;
				cfig.sockAddr[2].sin_addr.s_addr = cfig.dnsRoutes[routeDNS].dns;
				cfig.sockAddr[2].sin_port = htons(IPPORT_DNS);

				errno = 0;
				nRet = sendto(cfig.socket[2],
				              req->raw,
				              req->bytes,
				              0,
				              (LPSOCKADDR) & cfig.sockAddr[2],
				              sizeof(cfig.sockAddr[2]));

				if (!errno && nRet > 0)
				{
					if (verbatim)
						printf("%s Routed to DNS %s\n", req->cname, IP2String(cfig.dnsRoutes[routeDNS].dns));

					break;
				}
			}
		}
	}

	if (tryDefault)
	{
		//printf("Queries Failed = %i currentDNS=%i\n", cfig.queriesFailed, cfig.currentDNS);
		if (cfig.queriesFailed >= 5)
		{
			if (cfig.currentDNS < 4)
				cfig.currentDNS++;

			cfig.queriesFailed = 0;
		}

		if (!cfig.dns[cfig.currentDNS])
		{
			getdnserv();
			cfig.currentDNS = 0;
		}

		if (!cfig.dns[cfig.currentDNS])
			return 0;

		if (req->sockAddr.sin_addr.s_addr != cfig.dns[cfig.currentDNS])
		{
			cfig.sockAddr[2].sin_family = AF_INET;
			cfig.sockAddr[2].sin_addr.s_addr = cfig.dns[cfig.currentDNS];
			cfig.sockAddr[2].sin_port = htons(IPPORT_DNS);

			errno = 0;
			nRet = sendto(cfig.socket[2],
			              req->raw,
			              req->bytes,
			              0,
			              (LPSOCKADDR) & cfig.sockAddr[2],
			              sizeof(cfig.sockAddr[2]));
		}

		if (!errno && nRet > 0)
		{
			if (verbatim)
				printf("%s Forwarded to DNS %s\n", req->cname, IP2String(cfig.dns[cfig.currentDNS]));
		}
		else
			return 0;
	}

	if (!queue)
	{
		queue = (data7*)malloc(sizeof(data7));
		if (queue)
		{
			memset(queue, 0, sizeof(data7));
			queue->mapname = (char*)malloc(strlen(mapname) + 1);
			strcpy(queue->mapname, mapname);
			queue->dataType = QUEUE;
			queue->expiry = 5 + time(NULL);
			dnsCache[queue->mapname] = queue;
			dnsAge.insert(pair<long, data7*>(queue->expiry, queue));
		}
		else if (verbatim)
			printf("memory error\n");
	}
	else if (queue->dataType == QUEUE)
	{
		if (tryDefault)
		{
			queue->defaultDNS = cfig.currentDNS;
			queue->routeDNS = UCHAR_MAX;
		}
		else
		{
			queue->defaultDNS = UCHAR_MAX;
			queue->routeDNS = routeDNS;
		}
		return (req->bytes);
	}

	if (queue)
	{
		if (tryDefault)
		{
			queue->defaultDNS = cfig.currentDNS;
			queue->routeDNS = UCHAR_MAX;
		}
		else
		{
			queue->defaultDNS = UCHAR_MAX;
			queue->routeDNS = routeDNS;
		}

		queue->source = (SOCKADDR_IN*)malloc(sizeof(SOCKADDR_IN));
		memcpy(queue->source, &req->sockAddr, sizeof(SOCKADDR_IN));
		queue->query = (char*)malloc(strlen(req->query) + 1);
		strcpy(queue->query, req->query);
		//printf("queued %s=%s\n", req->mapname, mapname);
		return (req->bytes);
	}

	return 0;
}

WORD frdnmess(data5 *req)
{
	char mapname[8];
	socklen_t nRet = sizeof(cfig.sockAddr[2]);
	errno = 0;
	req->bytes = recvfrom(cfig.socket[2],
	                      req->raw,
	                      sizeof(dnsPacket),
	                      0,
	                      (LPSOCKADDR) & cfig.sockAddr[2],
	                      &nRet);

	if (req->bytes <= 0 || errno)
		return 0;

	sprintf(mapname, "%u", req->dnsp.header.xid);
	checkSize();
	data7 *queue = dnsCache[mapname];

	if (queue && queue->dataType == QUEUE && queue->expiry > time(NULL))
	{
		if (queue->defaultDNS == cfig.currentDNS)
		{
			cfig.queriesFailed = 0;
		}

		queue->expiry = 0;
		memcpy(&req->sockAddr, queue->source, sizeof(SOCKADDR_IN));
		strcpy(req->query, queue->query);

		if (ntohs(req->dnsp.header.ancount))
		{
			char *raw = req->dnsp.data;
			fQu(req->cname, &req->dnsp, raw);
			strcpy(req->mapname, req->cname);
			myLower(req->mapname);

			char *dp = strstr(req->mapname, ".in-addr.arpa");
			if (dp)
				*dp = 0;

			data7 *cache = dnsCache[req->mapname];
			if (cache)
			{
				cache->expiry = getExpiry(&req->dnsp);
				if (cache->dataType != CACHED || cache->bytes < req->bytes)
				{
					free(cache->response);
					cache->response = (char*)malloc(req->bytes);
					cache->dataType = CACHED;
				}
			}
			else
			{
				cache = (data7*)malloc(sizeof(data7));
				if (cache)
				{
					memset(cache, 0, sizeof(data7));
					cache->expiry = getExpiry(&req->dnsp);
					cache->mapname = (char*)malloc(strlen(req->mapname) + 1);
					cache->response = (char*)malloc(req->bytes);
					if (cache->mapname)
					{
						strcpy(cache->mapname, req->mapname);
						cache->dataType = CACHED;
						dnsCache[cache->mapname] = cache;
						dnsAge.insert(pair<long, data7*>(cache->expiry, cache));
					}
				}
			}

			if (cache->response)
			{
				memcpy(cache->response, &req->dnsp, req->bytes);
				cache->bytes = req->bytes;
				memcpy(&req->cache, cache, sizeof(data7));
				return genMess(req);
			}
			else
				return 0;
		}
		else
		{
			memset(&req->cache, 0, sizeof(data7));
			return genMess(req);
		}
	}

	req->bytes = 0;
	req->dnsp.header.aa = 0;
	return req->bytes;
}

char* getResult(dnsPacket *mess)
{
	tempbuff[0] = 0;
	char extrabuff[256];
	char *raw = mess->data;
	WORD queueIndex;

	for (int i = 1; i <= ntohs(mess->header.qdcount); i++)
	{
		raw += fQu(extrabuff, mess, raw);
		raw += 4;
	}

	for (int i = 1; i <= ntohs(mess->header.ancount); i++)
	{
		raw += fQu(extrabuff, mess, raw);
		int type = fShort(raw);
		raw += 2; //type
		raw += 2; //class
		raw += 4; //ttl
		int dlen = fShort(raw);
		raw += 2; //datalength
		if (type == DNS_TYPE_A)
			return IP2String(*(DWORD*)raw);
		else if (type == DNS_TYPE_PTR)
		{
			fQu(tempbuff, mess, raw);
			return tempbuff;
		}
		else if (type == DNS_TYPE_CNAME)
			fQu(tempbuff, mess, raw);
		else if (type == DNS_TYPE_MX)
			fQu(tempbuff, mess, ++++raw);
		raw += dlen;
	}
	if (tempbuff[0])
		return tempbuff;
	else
		return NULL;
}

time_t getExpiry(dnsPacket *mess)
{
	time_t currentTime = time(NULL);
	char *raw = mess->data;

	for (int i = 1; i <= ntohs(mess->header.qdcount); i++)
	{
		raw += fQu(tempbuff, mess, raw);
		raw += 4;
	}

	time_t expiry = LONG_MAX;
	for (int i = 1; i <= ntohs(mess->header.ancount); i++)
	{
		raw += fQu(tempbuff, mess, raw);
		raw += 4;

		if (expiry > fLong(raw))
			expiry = fLong(raw);

		raw += 4;
		raw += fShort(raw) + 2;
	}

	if (LONG_MAX - currentTime < expiry)
		return LONG_MAX;
	else
		return (expiry + currentTime);
}

BYTE *gvdata(BYTE *raw, data1 *req, data3 *op)
{
	while (*raw == 0)
		if (raw == req->dhcpp.bp_vend + DHCP_VENDORDATA_SIZE)
			return NULL;
		else
			raw++;

	if (*raw == DHCP_OPTION_END)
		return NULL;

	op->opt_code = *raw;
	raw++;
	op->size = *raw;
	raw++;
	memcpy(op->value, raw, op->size);
	raw += op->size;
	//printf("\n%u %u",op->opt_code, op->size);
	return raw;
}

WORD gdmess(data1 *req)
{
	memset(req, 0, sizeof(data1));

	errno = 0;
	socklen_t nLen = sizeof(req->sockAddr);
	req->bytes = recvfrom(cfig.socket[0],
	                      req->raw,
	                      sizeof(dhcp_packet),
	                      0,
	                      (LPSOCKADDR) & req->sockAddr,
	                      &nLen);

	if (errno)
		return 0;

	if (!cfig.servers[0])
		glocal();

	if (!cfig.servers[0])
		return 0;

	//printf("here\n");

	data3 op;
	BYTE *raw = req->dhcpp.bp_vend;

	while (raw = gvdata(raw, req, &op))
	{
		switch (op.opt_code)
		{
		case DHCP_OPTION_PARAMREQLIST:
			for (int ix = 0; ix < op.size; ix++)
				req->paramreqlist[op.value[ix]] = 1;
			break;

		case DHCP_OPTION_MESSAGETYPE:
			req->req_type = op.value[0];
			break;

		case DHCP_OPTION_SERVERID:
			req->server = op.longvalue;
			break;

		case DHCP_OPTION_IPADDRLEASE:
			req->lease = htonl(op.longvalue);
			break;

		case DHCP_OPTION_MAXDHCPMSGSIZE:
			req->messsize = htons(op.shortvalue);
			break;

		case DHCP_OPTION_REQUESTEDIPADDR:
			req->reqIP = op.longvalue;
			break;

		case DHCP_OPTION_HOSTNAME:
			if (op.size && strcasecmp(op.charvalue, "(none)"))
			{
				memcpy(req->hostname, op.value, op.size);
				req->hostname[op.size] = 0;
				char *dp = strchr(req->hostname, '.');
				if (dp != NULL)
					*dp = 0;
			}
			break;
		}
	}
	return req->req_type;
}

DWORD resad(data1 *req)
{
	int proposed_candidate = -1;
	int expired_candidate = -1;
	int i;
	BYTE empty[10];
	memset(empty, 0, sizeof(empty));
	time_t currentTime = currentTime;

	if (!cfig.servers[0])
		return 0;

	int j = cfig.ranges[0].rangeEnd - cfig.ranges[0].rangeStart;

	for (i = 0; i <= j; i++)
	{
		if (!cfig.clients[i].server)
		{
			if (!memcmp(req->dhcpp.bp_chaddr, cfig.clients[i].chaddr, sizeof(empty)))
				break;
			else if ((cfig.clients[i].hostname[0] && !strcasecmp(req->hostname, cfig.clients[i].hostname)) || (proposed_candidate < 0 && !cfig.clients[i].static_host && !memcmp(cfig.clients[i].chaddr, empty, sizeof(empty))))
				proposed_candidate = i;
			else if (!cfig.clients[i].static_host && expired_candidate < 0 && memcmp(cfig.clients[i].chaddr, empty, sizeof(empty)) && cfig.clients[i].expiry < currentTime)
				expired_candidate = i;
		}
	}

	if (i <= j)
		proposed_candidate = i;
	else if (proposed_candidate < 0 && expired_candidate >= 0)
		proposed_candidate = expired_candidate;
	else if (proposed_candidate < 0)
		return 0;

	if (req->hostname[0])
		strcpy(cfig.clients[proposed_candidate].hostname, req->hostname);
	else if (cfig.clients[proposed_candidate].hostname[0])
		strcpy(req->hostname, cfig.clients[proposed_candidate].hostname);

	if (!cfig.messsize[proposed_candidate])
		cfig.messsize[proposed_candidate] = sizeof(dhcp_packet);

	if (req->messsize)
		cfig.messsize[proposed_candidate] = req->messsize;
	else
		req->messsize = cfig.messsize[proposed_candidate];

	memcpy(cfig.clients[proposed_candidate].chaddr, req->dhcpp.bp_chaddr, sizeof(empty));

	if (!cfig.clients[proposed_candidate].static_host)
		cfig.clients[proposed_candidate].expiry = currentTime + 120;

	return htonl(cfig.ranges[0].rangeStart + proposed_candidate);
}

DWORD chad(DWORD ip, data1 *req)
{
	int j = getIndex(ip);

	if (j >= 0)
	{
		if (!memcmp(req->dhcpp.bp_chaddr, cfig.clients[j].chaddr, 10))
		{
			if (req->hostname[0])
				strcpy(cfig.clients[j].hostname, req->hostname);
			else if (cfig.clients[j].hostname[0])
				strcpy(req->hostname, cfig.clients[j].hostname);

			return ip;
		}
	}
	return 0;
}

DWORD alad(data1 *req)
{
	time_t currentTime = time(NULL);
	int j = getIndex(req->dhcpp.bp_yiaddr);

	if (j >= 0)
	{
		if (!cfig.clients[j].static_host && LONG_MAX - currentTime > req->lease)
			cfig.clients[j].expiry = currentTime + req->lease;
		else
			cfig.clients[j].expiry = LONG_MAX;

		if (req->hostname[0])
			addToCache(req->hostname, req->dhcpp.bp_yiaddr, cfig.clients[j].expiry, LOCAL_A, LOCAL_PTR);

		FILE *f = fopen(leaFile, "rb+");
		if (f)
		{
			fseek(f, 4 + j*sizeof(data8), SEEK_SET);
			fwrite(&cfig.clients[j], sizeof(data8), 1, f);
			fclose(f);
		}
		return req->dhcpp.bp_yiaddr;
	}
	return 0;
}

void addToCache(char *hostname, DWORD ip, time_t expiry, BYTE aType, BYTE pType)
{
	//printf("Adding %s exp=%u\n",hostname,expiry);

	if (!hostname[0] || !ip)
		return ;

	IP2String(htonl(ip));
	checkSize();
	data7 *cache = dnsCache[tempbuff];

	if (!cache)
	{
		cache = (data7*)malloc(sizeof(data7));
		if (cache)
		{
			memset(cache, 0, sizeof(data7));
			cache->mapname = (char*)malloc(strlen(tempbuff) + 1);
			cache->response = (char*)malloc(strlen(hostname) + 1);
			if (cache->mapname && cache->response)
			{
				strcpy(cache->mapname, tempbuff);
				strcpy(cache->response, hostname);
				cache->dataType = pType;
				cache->expiry = expiry;
				dnsCache[cache->mapname] = cache;

				if (cache->expiry < LONG_MAX)
					dnsAge.insert(pair<long, data7*>(cache->expiry, cache));
			}
		}
		else if (verbatim)
			printf("memory error\n");
	}
	else
	{
		if (strcasecmp(tempbuff, cache->response))
		{
			free(cache->response);
			cache->response = (char*)malloc(strlen(tempbuff) + 1);
			if (cache->response)
			{
				strcpy(cache->response, hostname);
			}
		}
		if (cache->expiry < LONG_MAX)
			cache->expiry = expiry;
	}

	myLower(hostname);
	checkSize();
	cache = dnsCache[hostname];

	if (!cache)
	{
		cache = (data7*)malloc(sizeof(data7));
		if (cache)
		{
			memset(cache, 0, sizeof(data7));
			cache->mapname = (char*)malloc(strlen(hostname) + 1);
			if (cache->mapname)
			{
				strcpy(cache->mapname, hostname);
				cache->ip = ip;
				cache->dataType = aType;
				cache->expiry = expiry;
				dnsCache[cache->mapname] = cache;

				if (cache->expiry < LONG_MAX)
					dnsAge.insert(pair<long, data7*>(cache->expiry, cache));
			}
			else if (verbatim)
				printf("memory error\n");
		}
		else if (verbatim)
			printf("memory error\n");
	}
	else
	{
		cache->ip = ip;
		if (cache->expiry < LONG_MAX)
			cache->expiry = expiry;
	}
}

DWORD sdmess(data1 *req)
{
	if (req->req_type == DHCP_MESS_DECLINE)
	{
		req->dhcpp.bp_yiaddr = resad(req);
		int j = getIndex(req->dhcpp.bp_yiaddr);
		if (j >= 0)
			cfig.clients[j].static_host = true;
		return 0;
	}
	else if (req->req_type == DHCP_MESS_RELEASE)
	{
		int j = getIndex(req->dhcpp.bp_ciaddr);
		if (j >= 0)
		{
			cfig.clients[j].expiry = time(NULL);
			if (cfig.clients[j].hostname[0])
				addToCache(cfig.clients[j].hostname, req->dhcpp.bp_ciaddr, cfig.clients[j].expiry, LOCAL_A, LOCAL_PTR);
		}
		return 0;
	}
	else if (req->req_type == DHCP_MESS_INFORM)
		return 0;
	else if (req->req_type == DHCP_MESS_DISCOVER && strcasecmp(req->hostname, cfig.servername))
	{
		req->resp_type = DHCP_MESS_OFFER;
		req->dhcpp.bp_yiaddr = resad(req);
		if (!req->dhcpp.bp_yiaddr)
			return 0;
	}
	else if (req->req_type == DHCP_MESS_REQUEST)
	{
		if (req->server)
		{
			if (req->server == cfig.servers[0] || req->server == cfig.serverip)
			{
				if (req->reqIP && chad(req->reqIP, req))
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.bp_yiaddr = req->reqIP;
				}
				else if (req->dhcpp.bp_ciaddr && chad(req->dhcpp.bp_ciaddr, req))
				{
					req->resp_type = DHCP_MESS_ACK;
					req->dhcpp.bp_yiaddr = req->dhcpp.bp_ciaddr;
				}
				else if (cfig.authorized)
				{
					req->resp_type = DHCP_MESS_NAK;
					req->dhcpp.bp_yiaddr = 0;
				}
				else
				{
					req->resp_type = DHCP_MESS_DECLINE;
					req->dhcpp.bp_yiaddr = 0;
				}
			}
			else if (cfig.authorized)
			{
				req->resp_type = DHCP_MESS_NAK;
				req->dhcpp.bp_yiaddr = 0;
			}
			else
				return 0;
		}
		else if (req->dhcpp.bp_ciaddr)
		{
			if (chad(req->dhcpp.bp_ciaddr, req))
			{
				req->resp_type = DHCP_MESS_ACK;
				req->dhcpp.bp_yiaddr = req->dhcpp.bp_ciaddr;
			}
			else if (cfig.authorized)
			{
				req->resp_type = DHCP_MESS_NAK;
				req->dhcpp.bp_yiaddr = 0;
			}
			else
			{
				req->resp_type = DHCP_MESS_DECLINE;
				req->dhcpp.bp_yiaddr = 0;
			}
		}
		else if (req->reqIP)
		{
			if (chad(req->reqIP, req))
			{
				req->resp_type = DHCP_MESS_ACK;
				req->dhcpp.bp_yiaddr = req->reqIP;
			}
			else if (cfig.authorized)
			{
				req->resp_type = DHCP_MESS_NAK;
				req->dhcpp.bp_yiaddr = 0;
			}
			else
			{
				req->resp_type = DHCP_MESS_DECLINE;
				req->dhcpp.bp_yiaddr = 0;
			}
		}
		else
			return 0;
	}
	else
		return 0;

	int j = (DWORD)addOp(req) - (DWORD) & req->dhcpp;

	req->sockAddr.sin_family = AF_INET;
	req->sockAddr.sin_port = htons(IPPORT_DHCPC);

	if (req->dhcpp.bp_ciaddr)
		req->sockAddr.sin_addr.s_addr = req->dhcpp.bp_ciaddr;
	else
		req->sockAddr.sin_addr.s_addr = INADDR_BROADCAST;

	errno = 0;
	req->bytes = sendto(cfig.socket[0],
	                    req->raw,
	                    j,
	                    0,
	                    (sockaddr*) & req->sockAddr,
	                    sizeof(req->sockAddr));

	if (!errno && req->resp_type == DHCP_MESS_ACK && req->bytes > 0 && req->dhcpp.bp_yiaddr)
		return alad(req);

	return 0;
}

BYTE *addOp(data1 *req)
{
	if (!req->messsize)
		req->messsize = sizeof(dhcp_packet);

	data3 op;
	int i;

	memset(req->dhcpp.bp_vend, 0, DHCP_VENDORDATA_SIZE);
	BYTE *vp = req->dhcpp.bp_vend;

	op.opt_code = DHCP_OPTION_MESSAGETYPE;
	op.size = 1;
	op.value[0] = req->resp_type;
	vp = pvdata(vp, req, &op);

	if (req->resp_type != DHCP_MESS_DECLINE && req->resp_type != DHCP_MESS_NAK)
	{
		if (req->lease == 0 || req->lease > cfig.lease)
			req->lease = cfig.lease;

		op.opt_code = DHCP_OPTION_IPADDRLEASE;
		op.size = 4;
		op.longvalue = htonl(req->lease);
		vp = pvdata(vp, req, &op);

		strcpy(req->dhcpp.bp_sname, cfig.servername_fqn);

		op.opt_code = DHCP_OPTION_NETMASK;
		op.size = 4;
		op.longvalue = cfig.subnetmask;
		vp = pvdata(vp, req, &op);

		op.opt_code = DHCP_OPTION_SERVERID;
		op.size = 4;

		if (cfig.serverip)
			op.longvalue = cfig.serverip;
		else
			op.longvalue = cfig.servers[0];

		vp = pvdata(vp, req, &op);

		op.opt_code = DHCP_OPTION_DOMAINNAME;
		op.size = strlen(cfig.domainname);
		memcpy(op.value, cfig.domainname, op.size);
		vp = pvdata(vp, req, &op);

		BYTE *opPointer = cfig.clientOptions[getIndex(req->dhcpp.bp_yiaddr)];
		BYTE requestedOnly = *opPointer;
		//printf("%i\n",RequestedOnly);
		opPointer++;

		while (*opPointer && *opPointer < UCHAR_MAX)
		{
			op.size = *(opPointer + 1);
			if (!requestedOnly || req->paramreqlist[*opPointer])
			{
				op.opt_code = *opPointer;
				memcpy(op.value, opPointer + 2, op.size);
				vp = pvdata(vp, req, &op);
			}
			opPointer += (op.size + 2);
		}

		if (req->hostname[0])
		{
			op.opt_code = DHCP_OPTION_HOSTNAME;
			op.size = strlen(req->hostname);
			memcpy(op.value, req->hostname, op.size);
			vp = pvdata(vp, req, &op);
		}

		for (i = 0; i < 5; i++)
			if (!cfig.routers[i])
				break;

		if (i > 0)
		{
			op.opt_code = DHCP_OPTION_ROUTER;
			op.size = i * 4;
			memcpy(op.value, cfig.routers, op.size);
			vp = pvdata(vp, req, &op);
		}

		if (dnsService)
		{
			op.opt_code = DHCP_OPTION_DNS;
			if (cfig.serverip)
			{
				op.longvalue = cfig.serverip;
				op.size = 4;
				vp = pvdata(vp, req, &op);
			}
			else
			{
				for (i = 0; i < 5; i++)
					if (!cfig.servers[i])
						break;
				if (i > 0)
				{
					op.size = i * 4;
					memcpy(op.value, cfig.servers, op.size);
					vp = pvdata(vp, req, &op);
				}
			}
		}
		else
		{
			for (i = 0; i < 5; i++)
				if (!cfig.dns[i])
					break;
			if (i > 0)
			{
				op.opt_code = DHCP_OPTION_DNS;
				op.size = i * 4;
				memcpy(op.value, cfig.dns, op.size);
				vp = pvdata(vp, req, &op);
			}
		}

		opPointer = cfig.globalOptions;
		requestedOnly = *opPointer;

		opPointer++;
		while (*opPointer && *opPointer < UCHAR_MAX)
		{
			op.size = *(opPointer + 1);
			if (!requestedOnly || req->paramreqlist[*opPointer])
			{
				op.opt_code = *opPointer;
				memcpy(op.value, opPointer + 2, op.size);
				vp = pvdata(vp, req, &op);
			}
			opPointer += (op.size + 2);
		}
	}

	*vp = DHCP_OPTION_END;
	req->dhcpp.bp_op = DHCP_REPLY;
	return vp;
}

BYTE *pvdata(BYTE *vp, data1 *req, data3 *op)
{
	if (!req->opAdded[op->opt_code] && ((DWORD)vp - (DWORD)&req->dhcpp + op->size + 2 < req->messsize))
	{
		if (op->opt_code == DHCP_OPTION_BOOTFILE)
			memcpy(req->dhcpp.bp_file, op->charvalue, op->size);
		else if (op->opt_code == DHCP_OPTION_TFPTSERVERIPADDRESS)
			req->dhcpp.bp_siaddr = op->longvalue;
		else
		{
			*vp = op->opt_code;
			vp++;
			*vp = op->size;
			vp++;
			memcpy(vp, op->value, op->size);
			vp += op->size;
		}
		req->opAdded[op->opt_code] = true;
	}
	return vp;
}

void indata()
{
	memset(&cfig, 0, sizeof(data2));

	cfig.ranges[0].rangeStart = htonl(my_inet_addr("192.168.0.1"));
	cfig.ranges[0].rangeEnd = cfig.ranges[0].rangeStart + DHCP_MAX_CLIENTS - 1;
	cfig.lease = 36000;

	char iniStr[8192];

	if (getSection("SERVICES", iniStr, sizeof(iniStr), iniFile))
	{
		dhcpService = false;
		dnsService = false;
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i < 2 && iniStrPtr[0]; i++, iniStrPtr = cleanstr(iniStrPtr, true))
			if (!strcasecmp(iniStrPtr, "DNS"))
				dnsService = true;
			else if (!strcasecmp(iniStrPtr, "DHCP"))
				dhcpService = true;
		if (!dhcpService && !dnsService)
		{
			dhcpService = true;
			dnsService = true;
		}
	}

	if (getSection("DOMAIN-NAME", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		char *value = strchr(iniStrPtr, '=');
		if (value)
		{
			if (*(value + 1) == 'A' || *(value + 1) == 'a' || *(value + 1) == '1')
				cfig.authorized = 1;
			*value = 0;
		}
		strcpy(cfig.domainname, iniStrPtr);
	}

	if (getSection("LISTEN-ON", iniStr, sizeof(iniStr), iniFile))
		cfig.serverip = my_inet_addr(cleanstr(iniStr, false));

	if (getSection("LEASE-SECONDS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		if (iniStrPtr[0])
			cfig.lease = atoi(iniStrPtr);
		if (!cfig.lease)
			cfig.lease = LONG_MAX;
	}

	if (getSection("IP-RANGES", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i <= 0, iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
		{
			char name[256];
			strncpy(name, iniStrPtr, 255);
			DWORD rs = 0;
			DWORD re = 0;
			char *temp = strchr(name, '-');
			if (temp)
			{
				*temp = 0;
				temp++;
				rs = htonl(my_inet_addr(name));
				re = htonl(my_inet_addr(temp));
			}
			if (rs && rs != INADDR_NONE && re && re != INADDR_NONE && (rs % 256) != 0 && (re % 256 != UCHAR_MAX) && (rs / 256) == (re / 256) && rs <= re)
			{
				cfig.ranges[i].rangeStart = rs;
				cfig.ranges[i].rangeEnd = re;
				i++;
			}
			else if (verbatim)
				printf("Section [IP-RANGES] Invalid IP range %s in ini file, ignored\n", iniStrPtr);
		}
	}
	cfig.network = getNetwork(htonl(cfig.ranges[0].rangeStart));

	FILE *f = fopen(leaFile, "rb");
	if (f)
	{
		DWORD rangeStart = 0;
		fread(&rangeStart, 4, 1, f);

		if (rangeStart == cfig.ranges[0].rangeStart)
			fread(cfig.clients, sizeof(data8), DHCP_MAX_CLIENTS, f);
		fclose(f);
	}

	f = fopen(leaFile, "wb");
	if (f)
	{
		fwrite(&cfig.ranges[0].rangeStart, 4, 1, f);
		fwrite(cfig.clients, sizeof(data8), DHCP_MAX_CLIENTS, f);
		fclose(f);
	}

	if (dnsService)
	{
		if (getSection("DNS-ALLOWED-HOSTS", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 1; i < 32 && iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				char name[256];
				strncpy(name, iniStrPtr, 255);
				DWORD rs = 0;
				DWORD re = 0;
				char *ptr = strchr(name, '-');
				if (ptr)
				{
					*ptr = 0;
					ptr++;
					rs = htonl(my_inet_addr(name));
					re = htonl(my_inet_addr(ptr));
				}
				else
				{
					rs = htonl(my_inet_addr(name));
					re = rs;
				}
				if (rs && rs != INADDR_NONE && re && re != INADDR_NONE && rs <= re)
				{
					cfig.ranges[i].rangeStart = rs;
					cfig.ranges[i].rangeEnd = re;
					i++;
				}
				else if (verbatim)
					printf("Section [DNS-ALLOWED-HOSTS] Invalid entry %s in ini file, ignored\n", iniStrPtr);
			}
		}

		if (getSection("STATIC-HOSTS", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 0; iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				char name[256];
				strncpy(name, iniStrPtr, UCHAR_MAX);
				char *value = strchr(name, '=');
				if (value != NULL)
				{
					*value = 0;
					value++;
					if (name[0] && value[0])
					{
						DWORD inetAddr = my_inet_addr(value);
						if (inetAddr > 0)
						{
							int ind = getIndex(inetAddr);
							if (ind >= 0)
							{
								cfig.clients[ind].static_host = 1;
								strcpy(cfig.clients[ind].hostname, name);
							}
							addToCache(name, inetAddr, LONG_MAX, STATIC_A, STATIC_PTR);
							i++;
						}
						else if (verbatim)
							printf("Section [STATIC-HOSTS] invalid entry %s ignored\n", iniStrPtr);
					}
					else if (verbatim)
						printf("Section [STATIC-HOSTS] invalid entry %s ignored\n", iniStrPtr);
				}
				else if (verbatim)
					printf("Section [STATIC-HOSTS] invalid entry %s ignored\n", iniStrPtr);
			}
		}

		if (getSection("ALIASES", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 0; iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				char name[512];
				strncpy(name, iniStrPtr, 511);
				char *value = strchr(name, '=');
				if (value != NULL)
				{
					*value = 0;
					value++;
					if (name[0] && value[0])
					{
						myLower(name);
						makeBare(name);
						data7 *cache = dnsCache[name];
						if (!cache)
						{
							cache = (data7*)malloc(sizeof(data7));
							if (cache)
							{
								memset(cache, 0, sizeof(data7));

								if (makeBare(value))
									cache->dataType = CNAME_LOCAL;
								else
									cache->dataType = CNAME_EXT;

								cache->expiry = LONG_MAX;
								cache->response = (char*)malloc(strlen(value) + 1);
								cache->mapname = (char*)malloc(strlen(name) + 1);

								if (cache->mapname && cache->response)
								{
									strcpy(cache->mapname, name);
									strcpy(cache->response, value);
									dnsCache[cache->mapname] = cache;
									i++;
								}
								else if (verbatim)
									printf("Section [ALIASES] entry %s memory error\n", iniStrPtr);
							}
							else if (verbatim)
								printf("Section [ALIASES] entry %s memory error\n", iniStrPtr);
						}
						else if (verbatim)
							printf("Section [ALIASES] duplicate entry %s ignored\n", iniStrPtr);
					}
					else if (verbatim)
						printf("Section [ALIASES] invalid entry %s ignored\n", iniStrPtr);
				}
				else if (verbatim)
					printf("Section [ALIASES] invalid entry %s ignored\n", iniStrPtr);

			}
		}

		if (getSection("MAIL-SERVERS", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 0; i < 5 && iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				char name[512];
				strncpy(name, iniStrPtr, 511);
				char *value = strchr(name, '=');
				if (value != NULL)
				{
					*value = 0;
					value++;
					if (name[0] && value[0])
					{
						cfig.mxServers[i].pref = atoi(value);
						if (!strchr(name, '.'))
						{
							strcat(name, ".");
							strcat(name, cfig.domainname);
						}
						strcpy(cfig.mxServers[i].hostname, name);
						i++;
					}
				}
			}
		}

		if (getSection("DNS-ROUTES", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 0; i < 5 && iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				char name[512];
				strncpy(name, iniStrPtr, 511);
				char *value = strchr(name, '=');
				if (value != NULL)
				{
					*value = 0;
					value++;
					if (name[0] && value[0])
					{
						myLower(name);
						char *dp = strstr(name, ".in-addr.arpa");
						if (dp)
							*dp = 0;
						DWORD ip = my_inet_addr(value);
						if (ip)
						{
							checkDNS(ip);
							strcpy(cfig.dnsRoutes[i].domain, name);
							cfig.dnsRoutes[i].dns = ip;
							i++;
						}
						else if (verbatim)
							printf("Section [DNS-ROUTES] invalid entry %s ignored\n", iniStrPtr);
					}
				}
			}
		}
	}

	int k = cfig.ranges[0].rangeEnd - cfig.ranges[0].rangeStart;
	for (int i = 0; i < k; i++)
	{
		if (cfig.clients[i].hostname[0] && cfig.clients[i].expiry > time(NULL))
			addToCache(cfig.clients[i].hostname, htonl(cfig.ranges[0].rangeStart + i), cfig.clients[i].expiry, LOCAL_A, LOCAL_PTR);
	}

	if (dhcpService)
	{

		if (getSection("DHCP-OPTIONS", iniStr, sizeof(iniStr), iniFile))
		{
			loadOptions(cfig.globalOptions, sizeof(cfig.globalOptions), iniStr, "DHCP OPTIONS", -1);
		}

		for (DWORD client = cfig.ranges[0].rangeStart; client <= cfig.ranges[0].rangeEnd; client++)
			if (getSection(IP2String(htonl(client)), iniStr, sizeof(iniStr), iniFile))
				loadOptions(cfig.clientOptions[client - cfig.ranges[0].rangeStart], sizeof(cfig.clientOptions[0]), iniStr, tempbuff, client - cfig.ranges[0].rangeStart);

		if (getSection("ROUTERS", iniStr, sizeof(iniStr), iniFile))
		{
			char *iniStrPtr = cleanstr(iniStr, false);
			for (int i = 0; i < 5, iniStrPtr[0]; iniStrPtr = cleanstr(iniStrPtr, true))
			{
				DWORD addr = my_inet_addr(iniStrPtr);
				if (addr)
				{
					addServer(cfig.routers, addr);
					i++;
				}
			}
		}
	}

	glocal();
	getdnserv();

	for (int i = 4; i >= 0; i--)
	{
		if (cfig.servers[i] && cfig.servername[0])
			addToCache(cfig.servername, cfig.servers[i], LONG_MAX, SERVER_A, SERVER_PTR);
	}
	addToCache("localhost", my_inet_addr("127.0.0.1"), LONG_MAX, SERVER_A, SERVER_PTR);
	sprintf(cfig.servername_fqn, "%s.%s", cfig.servername, cfig.domainname, SERVER_A, SERVER_PTR);

	if (dhcpService)
	{
		cfig.socket[0] = socket(AF_INET,
		                         SOCK_DGRAM,
		                         IPPROTO_UDP);

		if (cfig.socket[0] == INVALID_SOCKET)
			return ;

		cfig.sockAddr[0].sin_family = AF_INET;
		cfig.sockAddr[0].sin_addr.s_addr = INADDR_ANY;
		cfig.sockAddr[0].sin_port = htons(IPPORT_DHCPS);

		int bOptVal = true;
		int bOptLen = sizeof(bOptVal);
		//setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *) &n, sizeof(n);
		setsockopt(cfig.socket[0], SOL_SOCKET, SO_REUSEADDR, (char*)&bOptVal, bOptLen);
		int bOptVal1 = true;
		int bOptLen1 = sizeof(bOptVal1);
		setsockopt(cfig.socket[0], SOL_SOCKET, SO_BROADCAST, (char*)&bOptVal1, bOptLen1);

		int nRet = bind(cfig.socket[0],
		                (LPSOCKADDR) & cfig.sockAddr[0],
		                sizeof(struct sockaddr_in)
		               );

		if (nRet == SOCKET_ERROR)
		{
			close(cfig.socket[0]);
			if (verbatim)
				printf("Error: Port 67 already in use\n");
			else
				syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Port 67 already in use");
			scanf(tempbuff);
			exit(1);
		}
	}

	if (dnsService)
	{
		cfig.socket[1] = socket(AF_INET,
		                         SOCK_DGRAM,
		                         IPPROTO_UDP);

		if (cfig.socket[1] == INVALID_SOCKET)
			return ;

		cfig.sockAddr[1].sin_family = AF_INET;
		cfig.sockAddr[1].sin_addr.s_addr = cfig.serverip;
		cfig.sockAddr[1].sin_port = htons(IPPORT_DNS);

		int nRet = bind(cfig.socket[1],
		                (LPSOCKADDR) & cfig.sockAddr[1],
		                sizeof(struct sockaddr_in)
		               );
		if (nRet == SOCKET_ERROR)
		{
			if (cfig.socket[0])
				close(cfig.socket[0]);
			close(cfig.socket[1]);
			if (verbatim)
				printf("Error: Port 53 already in use\n");
			else
				syslog(LOG_MAKEPRI(LOG_LOCAL1, LOG_CRIT), "Port 53 already in use");
			exit(1);
		}

		cfig.socket[2] = socket(AF_INET,
		                         SOCK_DGRAM,
		                         IPPROTO_UDP);

		if (cfig.socket[2] == INVALID_SOCKET)
		{
			if (cfig.socket[0])
				close(cfig.socket[0]);
			if (cfig.socket[1])
				close(cfig.socket[1]);
			exit(1);
		}
	}
}

void glocal()
{
	gethostname(cfig.servername, sizeof(cfig.servername));

	if (!cfig.domainname[0])
	{
		getdomainname(cfig.domainname, sizeof(cfig.domainname));
		if (cfig.domainname[0])
			cfig.authorized = 1;
	}

	if (!strncmp(cfig.domainname, "(none)", 6) || !cfig.domainname[0])
	{
		strcpy(cfig.domainname, "workgroup");
		cfig.authorized = 1;
	}

	char buff[512];
	FILE *f = popen("/sbin/ifconfig", "r");
	bool eth = false;
	char *valueStart = NULL;
	char *valueEnd = NULL;
	char value[256];
	while (f && fgets(buff, sizeof(buff), f))
	{
		if (strstr(buff, "eth") == buff)
			eth = true;
		else if (strstr(buff, "  ") != buff)
			eth = false;

		if (eth && (valueStart = strstr(buff, "inet addr")))
		{
			valueStart += 10;
			valueEnd = strstr(valueStart, " ");
			if (!valueEnd)
				valueEnd = strstr(valueStart, "\n");
			if (valueEnd)
			{
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				DWORD addr = my_inet_addr(value);
				if (getNetwork(addr) == cfig.network)
					addServer(cfig.servers, addr);
			}
		}
		if (eth && (valueStart = strstr(buff, "Mask")))
		{
			valueStart += 5;
			valueEnd = strstr(valueStart, " ");
			if (!valueEnd)
				valueEnd = strstr(valueStart, "\n");
			if (valueEnd)
			{
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				cfig.subnetmask = my_inet_addr(value);
			}
		}
	}
	if (f)
		pclose(f);

	if (!cfig.routers[0])
	{
		f = popen("/sbin/route", "r");
		while (f && fgets(buff, sizeof(buff), f))
		{
			if (strstr(buff, "default") == buff || strstr(buff, "0.0.0.0") == buff)
			{
				valueStart = buff + 16;
				valueEnd = valueStart + 16;
				memcpy(value, valueStart, valueEnd - valueStart + 1);
				value[valueEnd - valueStart] = 0;
				int addr = my_inet_addr(value);
				if (!addr)
				{
					char *dot = strchr(value, 46);
					if (dot)
						*dot = 0;
					hostent *ent = gethostbyname(value);
					if (ent)
						addr = *(DWORD*)ent->h_addr_list[0];
				}
				if (getNetwork(addr) == cfig.network)
					addServer(cfig.routers, addr);
			}
		}
		if (f)
			pclose(f);
	}

	for (int i = 4; i >= 0; i--)
	{
		if (cfig.servers[i] && cfig.servername[0])
			addToCache(cfig.servername, cfig.servers[i], LONG_MAX, SERVER_A, SERVER_PTR);
	}

	DWORD ip = INADDR_ANY;

	if (cfig.serverip)
	{
		for (int i = 0; i < 5; i++)
		{
			if (getNetwork(cfig.servers[i]) == cfig.network)
				ip = cfig.servers[i];

			if (cfig.servers[i] == cfig.serverip)
			{
				if (dhcpService && getNetwork(cfig.serverip) != cfig.network)
				{
					if (verbatim)
						printf("Static Interface %s out of DHCP Range Network", IP2String(cfig.serverip));

					cfig.serverip = INADDR_ANY;
				}
			}
			else if (i == 4)
			{
				if (verbatim)
					printf("Static Interface %s not found", IP2String(cfig.serverip));

				cfig.serverip = INADDR_ANY;
			}
		}

		if (cfig.serverip == INADDR_ANY)
		{
			if (ip)
				cfig.serverip = ip;

			printf(", would listen on %s\n", IP2String(cfig.serverip));
		}
	}
}

void getdnserv()
{
	char iniStr[4096];

	DWORD *tservers = cfig.servers;

	DWORD dservers[5];
	for (int i = 0; i < 5; i++)
		dservers[i] = 0;

	if (getSection("DNS-SERVERS", iniStr, sizeof(iniStr), iniFile))
	{
		char *iniStrPtr = cleanstr(iniStr, false);
		for (int i = 0; i < 5 && iniStrPtr[0]; i++, iniStrPtr = cleanstr(iniStrPtr, true))
		{
			DWORD addr = my_inet_addr(iniStrPtr);
			addServer(dservers, addr);
		}
	}

	if (!dservers[0])
	{
		FILE *f = fopen("/etc/resolv.conf", "r");
		char buff[256];
		char *pin;
		DWORD addr;
		while (f && fgets(buff, 128, f))
		{
			if (pin = strstr(buff, "nameserver"))
			{
				pin += 11;
				DWORD addr = my_inet_addr(pin);
				addServer(dservers, addr);
			}
		}
		if (f)
			fclose(f);
	}

	for (int i = 0; i < 5 && dservers[i]; i++)
	{
		int j;
		for (j = 0; j < 5 && tservers[j]; j++)
			if (dservers[i] == tservers[j])
				break;

		if (dnsService && dservers[i] == tservers[j])
			continue;

		if (dnsService)
		{
			if (checkDNS(dservers[i]))
				addServer(cfig.dns, dservers[i]);
		}
		else
			addServer(cfig.dns, dservers[i]);
	}

	return ;
}

DWORD my_inet_addr(char* str)
{
	if (str == NULL)
		return INADDR_ANY;
	DWORD x = inet_addr(str);
	if (x == INADDR_NONE)
		return INADDR_ANY;
	else
		return x;
}

char* cleanstr(char* buff, BOOL next)
{
	if (buff[0] && next)
		buff += strlen(buff) + 1;
	while (*buff)
		if (*buff >= '0' && *buff <= '9' || *buff >= 'A' && *buff <= 'Z' || *buff >= 'a' && *buff <= 'z')
			break;
		else
			buff += strlen(buff) + 1;
	return buff;
}

char* IP2String(DWORD ip)
{
	in_addr inaddr;
	inaddr.s_addr = ip;
	sprintf(tempbuff, "%s", inet_ntoa(inaddr));
	return tempbuff;
}

BOOL getSection(char *sectionName, char *buffer, int sizeofbuffer, char *fileName)
{
	char section[128];
	sprintf(section, "[%s]", sectionName);
	myUpper(section);
	FILE *f = fopen(fileName, "r");
	char buff[512];
	char *temp = buffer;
	*temp = 0;
	BOOL found = false;
	while (f && !found && fgets(buff, 511, f))
	{
		myUpper(buff);
		if (strstr(buff, section) == buff)
		{
			found = true;
			while (fgets(buff, 511, f))
			{
				if (strstr(buff, "[") == buff)
					break;
				sprintf(temp, "%s", buff);
				temp += strlen(buff);
				while (*temp <= 32)
					temp--;
				temp++;
				*temp = 0;
				temp++;
			}
			*temp = 0;
		}
	}
	if (f)
		fclose(f);

	return found;
}

DWORD getNetwork(DWORD ip)
{
	union {
		DWORD network;
		BYTE x[4];
	} data;

	data.network = ip;
	data.x[3] = 0;

	if (data.x[0] < 192)
		data.x[2] = 0;

	if (data.x[0] < 128)
		data.x[1] = 0;

	return data.network;
}

BYTE addServer(DWORD *array, DWORD entry)
{
	for (BYTE i = 0; i < 5; i++)
	{
		if (!entry || array[i] == entry)
			return i;
		else if (!array[i])
		{
			array[i] = entry;
			int j = getIndex(entry);
			if (j >= 0)
				cfig.clients[j].server = true;
			return i;
		}
	}
	return UCHAR_MAX;
}

void loadOptions(BYTE *buff, WORD buffsize, char *iniStr, char *section, int clientIndex)
{
	//printf("clientbuffer%u=%u", clientIndex, buff);
	//printf("section=%s\n",section);
	BYTE *lastOptionIndex = NULL;
	BYTE *vp = buff;
	vp++;

	char *iniStrPtr = cleanstr(iniStr, false);
	while (iniStrPtr[0])
	{
		//printf("%i=%s\n", buffsize, iniStrPtr);
		char name[512];
		strncpy(name, iniStrPtr, 511);
		char *value = strchr(name, '=');
		if (value != NULL)
		{
			*value = 0;
			value++;
			if (name[0] && value[0])
			{
				BYTE opTag = atoi(name);
				if (opTag && opTag < UCHAR_MAX)
				{
					BYTE option[256];
					if (char* errorPos = getHexValue(option, value))
					{
						if (verbatim)
							printf("Warning section [%s] option %s position %u, Invalid char %c, option ignored\n", section, name, (DWORD)errorPos - (DWORD)value + 1, *(errorPos));
					}
					else if (buffsize > (option[0] + 2))
					{
						*vp = opTag;
						vp++;
						*vp = option[0];
						vp++;
						memcpy(vp, option + 1, option[0]);
						vp += option[0];
						buffsize -= (option[0] + 2);
					}
					else if (verbatim)
						printf("Warning section [%s] option %s no more space for options\n", section, name);
				}
				else
				{
					int i;
					for (i = 0; i < sizeof(op_index); i++)
						if (!strcasecmp(name, op_name[i]))
							break;
					if (i >= sizeof(op_index))
					{
						if (verbatim)
							printf("Warning section [%s] Invalid option %s, ignored\n", name);
					}
					else
					{
						//printf("%s=%i=%i\n",op_name[i],op_size[i],op_index[i]);
						if (op_size[i] < UCHAR_MAX && op_size[i] != 0 && (*value < '0' || *value > '9'))
						{
							if (verbatim)
								printf("Warning section [%s] option %s Numeric Value Required, option ignored\n", section, name);
						}
						else if (op_size[i] == 0)
						{
							int j = 0;
							char *temp = value;
							while (temp[0])
							{
								temp = strchr(temp, '.');
								if (temp)
								{
									j++;
									temp++;
								}
								else
									break;
							}
							if (j == 3 && (my_inet_addr(value) != INADDR_NONE || !strcasecmp(value, "UCHAR_MAX.UCHAR_MAX.UCHAR_MAX.UCHAR_MAX")))
							{
								DWORD inetAddr = my_inet_addr(value);
								if (buffsize > 6)
								{
									if (lastOptionIndex && *lastOptionIndex == op_index[i])
									{
										*(lastOptionIndex + 1) += 4;
									}
									else
									{
										lastOptionIndex = vp;
										*vp = op_index[i];
										vp++;
										*vp = 4;
										vp++;
										buffsize -= 2;
									}
									memcpy(vp, &inetAddr, 4);
									vp += 4;
									buffsize -= 4;
								}
								else if (verbatim)
									printf("Warning section [%s] option %s no more space for options\n", section, name);
							}
							else
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be 4 octates, option ignored\n", section, name);
							}
						}
						else if (op_size[i] == 4)
						{
							if (buffsize > 4)
							{
								lastOptionIndex = 0;
								long j = htonl(atol(value));
								*vp = op_index[i];
								vp++;
								*vp = 4;
								vp++;
								memcpy(vp, &j, 4);
								vp += 4;
								buffsize -= 6;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (op_size[i] == 2)
						{
							long j = htons(atol(value));
							if (j > USHRT_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be between 0 & %u, option ignored\n", section, name, USHRT_MAX);
							}
							else if (buffsize > 4)
							{
								if (lastOptionIndex && *lastOptionIndex == op_index[i])
								{
									*(lastOptionIndex + 1) += 2;
								}
								else
								{
									lastOptionIndex = vp;
									*vp = op_index[i];
									vp++;
									*vp = 2;
									vp++;
									buffsize -= 2;
								}
								memcpy(vp, &j, 2);
								vp += 2;
								buffsize -= 2;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (op_size[i] == 1)
						{
							lastOptionIndex = NULL;
							long j = atol(value);
							if (!strcasecmp(op_name[i], "Send_Only_Requested_Options"))
							{
								if (atoi(value) > 1)
								{
									if (verbatim)
										printf("Warning section [%s] option %s Value should be between 0 & 1, option ignored\n", section, name);
								}
								else
									*buff = atoi(value);
							}
							else if (j > UCHAR_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s Value should be between 0 & %u, option ignored\n", section, name, UCHAR_MAX);
							}
							else if (buffsize > 3)
							{
								*vp = op_index[i];
								vp++;
								*vp = 1;
								vp++;
								memcpy(vp, &j, 1);
								vp++;
								buffsize -= 3;
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
						else if (!strcasecmp(op_name[i], "Hardware_Addr") && clientIndex >= 0)
						{
							BYTE haddr[32];
							memset(haddr, 0, sizeof(haddr));
							if (!getHexValue(haddr, value))
							{
								for (int p = cfig.ranges[0].rangeEnd - cfig.ranges[0].rangeStart; p >= 0; p--)
								{
									if (p != clientIndex && !memcmp(cfig.clients[p].chaddr, haddr + 1, sizeof(cfig.clients[0].chaddr)))
									{
										memset(cfig.clients[p].chaddr, 0, sizeof(cfig.clients[0].chaddr));
										cfig.clients[p].static_host = 0;
										FILE *f = fopen(leaFile, "rb+");
										if (f)
										{
											fseek(f, 4 + p*sizeof(data8), SEEK_SET);
											fwrite(&cfig.clients[p], sizeof(data8), 1, f);
											fclose(f);
										}
									}
								}
								memcpy(cfig.clients[clientIndex].chaddr, haddr + 1, sizeof(cfig.clients[0].chaddr));
							}
							else if (verbatim)
								printf("Warning section [%s] option %s invalid value %s, option ignored\n", section, name, value);
						}
						else if (op_index[i] == DHCP_OPTION_HOSTNAME && strlen(value) < 64 && clientIndex >= 0)
						{
							lastOptionIndex = NULL;
							if (strchr(value, '.'))
							{
								if (verbatim)
									printf("Warning section [%s] entry %s should be bare name\n", section, iniStrPtr);
							}
							else
							{
								for (int p = cfig.ranges[0].rangeEnd - cfig.ranges[0].rangeStart; p >= 0; p--)
								{
									if (p != clientIndex && !strcasecmp(cfig.clients[p].hostname, value))
									{
										cfig.clients[p].hostname[0] = 0;
										cfig.clients[p].static_host = 0;
										FILE *f = fopen(leaFile, "rb+");
										if (f)
										{
											fseek(f, 4 + p*sizeof(data8), SEEK_SET);
											fwrite(&cfig.clients[p], sizeof(data8), 1, f);
											fclose(f);
										}
									}
								}
								strcpy(cfig.clients[clientIndex].hostname, value);
							}
						}
						else
						{
							lastOptionIndex = NULL;
							if (strlen(value) >= UCHAR_MAX)
							{
								if (verbatim)
									printf("Warning section [%s] option %s value too big, option ignored\n", section, name);
							}
							else if (buffsize > strlen(value))
							{
								*vp = op_index[i];
								vp++;
								*vp = strlen(value);
								vp++;
								memcpy(vp, value, strlen(value));
								vp += (strlen(value));
								buffsize -= (strlen(value) + 2);
							}
							else if (verbatim)
								printf("Warning section [%s] option %s no more space for options\n", section, name);
						}
					}
				}
			}
			else
			{
				if (verbatim)
					printf("Warning section [%s] option %s missing value, option ignored\n", section, name);
			}
		}
		else
		{
			if (verbatim)
				printf("Warning section [%s] option %s missing = sign, option ignored\n", section, name);
		}
		//printf("%i=%s\n", buffsize, iniStrPtr);
		iniStrPtr = cleanstr(iniStrPtr, true);
		//printf("\n%i\n",*vp);
	}
	*vp = DHCP_OPTION_END;
}

int getIndex(DWORD ip)
{
	DWORD ipTrans = htonl(ip);
	if (ipTrans >= cfig.ranges[0].rangeStart && ipTrans <= cfig.ranges[0].rangeEnd)
		return (ipTrans - cfig.ranges[0].rangeStart);
	else
		return -1;
}


char *getHexValue(BYTE *target, char *source)
{
	int i;
	for (i = 1; i <= 255 && *source; i++)
	{
		if (*source >= '0' && *source <= '9')
		{
			target[i] = (*source) - '0';
		}
		else if (*source >= 'a' && *source <= 'f')
		{
			target[i] = (*source) - 'a' + 10;
		}
		else if (*source >= 'A' && *source <= 'F')
		{
			target[i] = (*source) - 'A' + 10;
		}
		else
		{
			return source;
		}

		source++;

		if (*source >= '0' && *source <= '9')
		{
			target[i] *= 16;
			target[i] += (*source) - '0';
		}
		else if (*source >= 'a' && *source <= 'f')
		{
			target[i] *= 16;
			target[i] += (*source) - 'a' + 10;
		}
		else if (*source >= 'A' && *source <= 'F')
		{
			target[i] *= 16;
			target[i] += (*source) - 'A' + 10;
		}
		else if ((*source) == ':' || (*source) == '-')
		{
			source++;
			continue;
		}
		else if (*source)
		{
			return source;
		}
		else
		{
			*target = i;
			return NULL;
		}

		source ++;

		if (*source != ':' && *source != '-')
		{
			if (*source)
			{
				return source;
			}
			else
			{
				*target = i;
				return NULL;
			}
		}
		source++;

		if (!*source)
			return source - 1;
	}
	*target = i - 1;
	return NULL;
}

char *myUpper(char *string)
{
	char diff = 'a' - 'A';
	WORD len = strlen(string);
	for (int i = 0; i < len; i++)
		if (string[i] >= 'a' && string[i] <= 'z')
			string[i] -= diff;
	return string;
}

char *myLower(char *string)
{
	char diff = 'a' - 'A';
	WORD len = strlen(string);
	for (int i = 0; i < len; i++)
		if (string[i] >= 'A' && string[i] <= 'Z')
			string[i] += diff;
	return string;
}

BYTE makeBare(char *query)
{
	char *dp = strchr(query, '.');
	if (dp)
	{
		if (!strcasecmp(dp + 1, cfig.domainname))
		{
			*dp = 0;
			return 1;
		}
		else
			return 0;
	}
	else
		return 1;
}

void checkSize()
{
	//printf("%u=%u\n",dnsCache.size(),dnsAge.size());

	time_t currentTime = time(NULL);

	if (dnsAge.size() == 0)
		return ;

	data7 *cache = NULL;
	myMultiMap::iterator p = dnsAge.begin();
	myMultiMap::iterator q;

	while (true)
	{
		if (p == dnsAge.end())
			return ;

		cache = (*p).second;
		//printf("processing %s=%i\n", cache->mapname, (*p).first - currentTime);

		if ((*p).first > currentTime)
			return ;
		else if (cache->expiry < currentTime)
		{
			q = p;
			p++;
			dnsAge.erase(q);
			dnsCache.erase(cache->mapname);
			//printf("deleted %s=%s=%i=%i\n", cache->mapname, cache->query, cache->expiry - currentTime, dnsAge.size());
			switch (cache->dataType)
			{
			case LOCAL_PTR:
			case SERVER_PTR:
			case STATIC_PTR:
			case CNAME_LOCAL:
			case CNAME_EXT:
			case CACHED:
				free(cache->response);
				free(cache->mapname);
				break;
			case LOCAL_A:
			case SERVER_A:
			case STATIC_A:
				free(cache->mapname);
				break;
			case QUEUE:
				free(cache->query);
				free(cache->source);
				free(cache->mapname);

				if (cfig.queriesFailed < 255 && cache->defaultDNS == cfig.currentDNS && cache->expiry)
					cfig.queriesFailed++;

				break;
			}
			free(cache);
			return ;
		}
		else if (cache->expiry > (*p).first)
		{
			q = p;
			p++;
			dnsAge.erase(q);
			dnsAge.insert(pair<long, data7*>(cache->expiry, cache));
		}
		else
			p++;
	}
}

DWORD checkDNS(DWORD ip)
{
	DWORD srvOK = 0;
	cfig.socket[3] = socket(AF_INET,
	                        SOCK_DGRAM,
	                        IPPROTO_UDP);
	timeval tv1;
	fd_set readfds1;
	dnsPacket mess;
	memset(&mess, 0, sizeof(mess));

	mess.header.xid = 6;
	mess.header.qdcount = htons(1);
	mess.header.rd = 1;
	char *raw = mess.data;
	raw += pQu(raw, "1.0.0.127.in-addr.arpa");
	raw += pShort(raw, DNS_TYPE_PTR);
	raw += pShort(raw, DNS_CLASS_IN);

	cfig.sockAddr[3].sin_family = AF_INET;
	cfig.sockAddr[3].sin_addr.s_addr = ip;
	cfig.sockAddr[3].sin_port = htons(IPPORT_DNS);

	tv1.tv_sec = 5;
	tv1.tv_usec = 0;

	int nRet = sendto(cfig.socket[3],
	                  (const char*) & mess,
	                  sizeof(dnsHeader) + ((DWORD)raw - (DWORD)mess.data),
	                  0,
	                  (LPSOCKADDR) & cfig.sockAddr[3],
	                  sizeof(cfig.sockAddr[3]));

	FD_ZERO(&readfds1);
	FD_SET(cfig.socket[3], &readfds1);
	select(USHRT_MAX, &readfds1, NULL, NULL, &tv1);

	if (FD_ISSET(cfig.socket[3], &readfds1))
	{
		errno = 0;
		socklen_t nLen = sizeof(cfig.sockAddr[3]);
		nRet = recvfrom(cfig.socket[3],
		                (char*) & mess,
		                sizeof(dnsPacket),
		                0,
		                (LPSOCKADDR) & cfig.sockAddr[3],
		                &nLen);

		if (!errno && nRet > 0)
			srvOK = ip;
	}

	closesocket(cfig.socket[3]);

	if (!srvOK && verbatim)
		printf("Warning:DNS Server %s could not be contacted\n", IP2String(ip));

	return srvOK;
	//return 1;
}

